//
// Copyright (c) 2009 Froduald Kabanza and the Université de Sherbrooke.
// Use of this software is permitted for non-commercial research purposes, and
// it may be copied or applied only for that use. All copies must include this
// copyright message.
// 
// This is a research prototype that has not gone through intensive tests and
// is delivered as is. It may still contain bugs. Froduald Kabanza and the
// Université de Sherbrooke disclaim any responsibility for damage that may be
// caused by using it.
//
// Please note that some files were inspired in part by the PDDL4J library:
// http://www.math-info.univ-paris5.fr/~pellier/software/software.php 
//
// Implementation: Simon Chamberland
// Project Manager: Froduald Kabanza
//

#include "stdafx.h"
#include "IAction.h"
#include "../Exp/BindingsIterator.h"

using namespace planning;

void IAction::instantiateAllActions(std::vector<const IGroundAction*>& actions) const
{
  BindingsIterator bIt(m_arguments);
  while (bIt.nextBinding())
  {
    IGroundAction* action = instantiateAction(&(bIt.getCurrentBindings()));
    // acquire()?
    actions.push_back(action);
  }
}

void IAction::_output(std::ostream& out) const
{
  out << "(" << m_name;
  for (argument_iterator it = m_arguments.begin();
       it != m_arguments.end();
       ++it)
  {
    out << " " << **it;
  }
  out << ")";
}